package cn.com.qmth.examcloud.exchange.inner.api.provider;

import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;


import cn.com.qmth.examcloud.commons.base.exception.StatusException;
import cn.com.qmth.examcloud.commons.web.support.ControllerSupport;
import cn.com.qmth.examcloud.exchange.inner.api.SendSmsCloudService;
import cn.com.qmth.examcloud.exchange.inner.api.request.CheckSmsCodeReq;
import cn.com.qmth.examcloud.exchange.inner.api.request.SendSmsReq;
import cn.com.qmth.examcloud.exchange.inner.service.SendSmsService;
import cn.com.qmth.examcloud.exchange.inner.service.bean.SendSmsInfo;

/**
 * 
 * @author chenken
 * @date 2018年7月3日 下午4:03:59
 * @company QMTH
 * @description SendSmsProvider.java
 */
@Controller
@RequestMapping("${$rmp.cloud.exchange.inner}" + "/sendSms")
public class SendSmsProvider extends ControllerSupport implements SendSmsCloudService {

	private static final long serialVersionUID = -1497756895732370672L;
	
	@Autowired
	private SendSmsService sendSmsService;

	@Override
	@RequestMapping(method = RequestMethod.POST, value = "/sendIdentifyingCode")
	public String sendIdentifyingCode(SendSmsReq sendSmsReq){
		SendSmsInfo sendSmsInfo = new SendSmsInfo();
		sendSmsInfo.setPhone(sendSmsReq.getPhone());
		sendSmsInfo.setCode(sendSmsReq.getCode());
		sendSmsInfo.setSign(sendSmsReq.getSign());
		sendSmsInfo.setTemplateCode(sendSmsReq.getTemplateCode());
		sendSmsInfo.setEffectiveTime(sendSmsReq.getEffectiveTime());
		sendSmsInfo.setIntervalSeconds(sendSmsReq.getIntervalSeconds());
		sendSmsService.sendIdentifyingCode(sendSmsInfo);
		return "";
	}
	
	@Override
	@RequestMapping(method = RequestMethod.POST, value = "/checkIdentifyingCode")
	public String checkIdentifyingCode(CheckSmsCodeReq checkSmsCodeReq){
		if(StringUtils.isBlank(checkSmsCodeReq.getPhone())){
			throw new StatusException("EX-SendSmsProvider-001", "手机号码不能为空");
		}
		if(StringUtils.isBlank(checkSmsCodeReq.getCode())){
			throw new StatusException("EX-SendSmsProvider-002", "验证码不能为空");
		}
		sendSmsService.checkIdentifyingCode(checkSmsCodeReq.getPhone(), checkSmsCodeReq.getCode());
		return "";
	}

}
